
<!DOCTYPE HTML>
<html lang="" >
    <head>
        <meta charset="UTF-8">
        <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
        <title>Ansible · GitBook</title>
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="description" content="">
        <meta name="generator" content="GitBook 3.2.3">
        
        
        
    
    <link rel="stylesheet" href="gitbook/style.css">

    
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-highlight/website.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-search/search.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-fontsettings/website.css">
                
            
        

    

    
        
    
        
    
        
    
        
    
        
    
        
    

        
    
    
    <meta name="HandheldFriendly" content="true"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <link rel="apple-touch-icon-precomposed" sizes="152x152" href="gitbook/images/apple-touch-icon-precomposed-152.png">
    <link rel="shortcut icon" href="gitbook/images/favicon.ico" type="image/x-icon">

    
    <link rel="next" href="Docker.html" />
    
    
    <link rel="prev" href="Vagrant.html" />
    

    </head>
    <body>
        
<div class="book">
    <div class="book-summary">
        
            
<div id="book-search-input" role="search">
    <input type="text" placeholder="Type to search" />
</div>

            
                <nav role="navigation">
                


<ul class="summary">
    
    

    

    
        
        
    
        <li class="chapter " data-level="1.1" data-path="./">
            
                <a href="./">
            
                    
                    Introdução
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.2" data-path="Vagrant.html">
            
                <a href="Vagrant.html">
            
                    
                    Vagrant
            
                </a>
            

            
        </li>
    
        <li class="chapter active" data-level="1.3" data-path="Ansible.html">
            
                <a href="Ansible.html">
            
                    
                    Ansible
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.4" data-path="Docker.html">
            
                <a href="Docker.html">
            
                    
                    Docker
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.5" data-path="GitBook.html">
            
                <a href="GitBook.html">
            
                    
                    GitBook
            
                </a>
            

            
        </li>
    

    

    <li class="divider"></li>

    <li>
        <a href="https://www.gitbook.com" target="blank" class="gitbook-link">
            Published with GitBook
        </a>
    </li>
</ul>


                </nav>
            
        
    </div>

    <div class="book-body">
        
            <div class="body-inner">
                
                    

<div class="book-header" role="navigation">
    

    <!-- Title -->
    <h1>
        <i class="fa fa-circle-o-notch fa-spin"></i>
        <a href="." >Ansible</a>
    </h1>
</div>




                    <div class="page-wrapper" tabindex="-1" role="main">
                        <div class="page-inner">
                            
<div id="book-search-results">
    <div class="search-noresults">
    
                                <section class="normal markdown-section">
                                
                                <h1 id="ansible">Ansible</h1>
<h2 id="o-que-&#xE9;-o-ansible">O que &#xE9; o Ansible:</h2>
<p>Ferramenta opensource, desenvolvido por Michael DeHann (Red Hat), que lhe possibilita realizar comunica&#xE7;&#xE3;o e integra&#xE7;&#xE3;o com diversos destinos de forma automatizada.</p>
<p>O Ansible trabalha em quatro vertentes:</p>
<ul>
<li><p>Gerenciamento de mudan&#xE7;as:</p>
<ul>
<li>Idempotente: Garante que a tarefa &#xE9; executada apenas uma &#xFA;nica vez atrav&#xE9;s do system state.</li>
<li>System State: Estado da m&#xE1;quina.</li>
<li>Vers&#xE3;o de aplica&#xE7;&#xF5;es: Permite cria&#xE7;&#xE3;o de rotinas para utilizar uma vers&#xE3;o de um determinado sistema. Caso algu&#xE9;m altere uma vers&#xE3;o o ansible consegue reverter as altera&#xE7;&#xF5;es e garantir a vers&#xE3;o correta.</li>
<li>Alerta de mudan&#xE7;as.</li>
</ul>
</li>
<li><p>Provisionamento:</p>
<ul>
<li>Configura&#xE7;&#xE3;o.</li>
<li>Instala&#xE7;&#xE3;o.</li>
<li>Prepara&#xE7;&#xE3;o.</li>
<li>Altera&#xE7;&#xE3;o do System State.</li>
</ul>
</li>
<li><p>Automa&#xE7;&#xE3;o:</p>
<ul>
<li>Execu&#xE7;&#xE3;o de tarefas de forma autom&#xE1;tica.</li>
<li>Ordena&#xE7;&#xE3;o de tarefas.</li>
<li>Realizar decis&#xF5;es.</li>
</ul>
</li>
<li><p>Orquestra&#xE7;&#xE3;o:</p>
<ul>
<li>M&#xFA;ltiplos servidores</li>
<li>M&#xFA;ltiplas aplica&#xE7;&#xF5;es</li>
<li>Diferentes tarefas</li>
<li>Ambiente h&#xED;brido</li>
</ul>
</li>
</ul>
<h2 id="como-funciona">Como funciona?</h2>
<p><img src="ansible-schema.png" alt="Ansible schema"></p>
<h2 id="configura&#xE7;&#xE3;o-do-ambiente">Configura&#xE7;&#xE3;o do ambiente</h2>
<p>Afim de facilitar a comunica&#xE7;&#xE3;o entre as m&#xE1;quinas iremos criar uma chave ssh na m&#xE1;quina principal e copiaremos a chave p&#xFA;blica para as m&#xE1;quinas targets.</p>
<p>Para cria&#xE7;&#xE3;o da chave e copia-lo para a m&#xE1;quina de destino, execute os comandos abaixo:</p>
<pre><code class="lang-sh">ssh-keygen -t rsa -b 4096
ssh-copy-id -i ~/.ssh/id_rsa.pub root@192.168.33.12
</code></pre>
<h2 id="instala&#xE7;&#xE3;o">Instala&#xE7;&#xE3;o</h2>
<pre><code class="lang-sh">sudo apt-add-repository ppa:ansible/ansible -y
sudo apt-get update &amp;&amp; sudo apt-get install ansible -y
</code></pre>
<h2 id="adhoc">Adhoc</h2>
<h3 id="o-que-s&#xE3;o-comandos-adhoc">O que s&#xE3;o comandos adhoc?</h3>
<p>Comandos utilizados para uma &#xFA;nica finalidade.</p>
<p>Estrutura dos comandos adhoc:</p>
<ul>
<li>ansible host -m [modulo] </li>
</ul>
<pre><code class="lang-sh">ansible -i hosts all <span class="hljs-_">-a</span> <span class="hljs-string">&quot;/sbin/reboot&quot;</span> --user root
ansible -i hosts all -m copy <span class="hljs-_">-a</span> <span class="hljs-string">&quot;src=/etc/hosts dest=/tmp/hosts&quot;</span>
ansible -i hosts all -m systemd <span class="hljs-_">-a</span> <span class="hljs-string">&quot;name=ssh state=stopped&quot;</span>
ansible -i hosts all -m setup
</code></pre>
<h2 id="modules">Modules</h2>
<ul>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_all_modules.html" target="_blank">All modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_cloud_modules.html" target="_blank">Cloud modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_clustering_modules.html" target="_blank">Clustering modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_commands_modules.html" target="_blank">Commands modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_crypto_modules.html" target="_blank">Crypto modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_database_modules.html" target="_blank">Database modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_files_modules.html" target="_blank">Files modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_identity_modules.html" target="_blank">Identity modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_inventory_modules.html" target="_blank">Inventory modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_messaging_modules.html" target="_blank">Messaging modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_monitoring_modules.html" target="_blank">Monitoring modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_net_tools_modules.html" target="_blank">Net Tools modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_network_modules.html" target="_blank">Network modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_notification_modules.html" target="_blank">Notification modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_packaging_modules.html" target="_blank">Packaging modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_remote_management_modules.html" target="_blank">Remote Management modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_source_control_modules.html" target="_blank">Source Control modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_storage_modules.html" target="_blank">Storage modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_system_modules.html" target="_blank">System modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_utilities_modules.html" target="_blank">Utilities modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_web_infrastructure_modules.html" target="_blank">Web Infrastructure modules</a></li>
<li><a href="https://docs.ansible.com/ansible/2.9/modules/list_of_windows_modules.html" target="_blank">Windows modules</a></li>
</ul>
<h2 id="roles">Roles</h2>
<h3 id="o-que-s&#xE3;o-roles">o que s&#xE3;o roles?</h3>
<p>As roles (fun&#xE7;&#xF5;es) s&#xE3;o um conjunto de itens independentes destinados a provisionar uma determinada aplica&#xE7;&#xE3;o/infraestrutura...</p>
<p>As roles possuem uma estrutura padr&#xE3;o de diret&#xF3;rios para seus projetos:</p>
<pre><code class="lang-sh">playbook.yml
roles/
    common/
        tasks/
        handlers/
        files/
        templates/
        vars/
        defaults/
        meta/
</code></pre>
<ul>
<li>Tasks: lista de tarefas a serem executadas em uma role.</li>
<li>Handlers: s&#xE3;o eventos acionados por uma task.</li>
<li>Files: arquivos utilizados para deploy dentro de uma role.</li>
<li>Templates: modelos para deploy dentro de uma role (Permite uso de vari&#xE1;veis.)</li>
<li>Vars: vari&#xE1;veis adicionais de uma role.</li>
<li>Defaults: variaveis padr&#xE3;o de uma role. Prioridade m&#xE1;xima.</li>
<li>Meta: trata depend&#xEA;ncias de uma role por outra role.</li>
</ul>
<h2 id="playbooks">Playbooks</h2>
<p>Permite gerenciar e orquestrar v&#xE1;rias m&#xE1;quinas de forma mais simples do que quando utilizado a op&#xE7;&#xE3;o adhoc.
Adhoc &#xE9; utilizado apenas para realizar tarefas simples.
<a href="https://docs.ansible.com/ansible/latest/user_guide/playbooks.html" target="_blank">Link da documenta&#xE7;&#xE3;o</a></p>
<pre><code class="lang-yaml"><span class="hljs-meta">---</span>
<span class="hljs-attr">- name:</span> Apache playbook
<span class="hljs-attr">  hosts:</span> apache
<span class="hljs-attr">  roles:</span>
<span class="hljs-bullet">    -</span> apache  

...
</code></pre>
<h2 id="lista-de-comandos">Lista de comandos:</h2>
<pre><code class="lang-bash">ansible-playbook --help

ansible-playbook -{op&#xE7;&#xF5;es} playbook-criada.yml

ansible-playbook -i hosts  playbook-criada.yml

ansible-playbook -i hosts  playbook-criada.yml --syntex-check <span class="hljs-comment">#verifica sintaxe dos arquivos. N&#xE3;o executa.</span>

ansible-playbook -i hosts  playbook-criada.yml --check <span class="hljs-comment">#simula a execu&#xE7;&#xE3;o da playbook mas sem realizar altera&#xE7;&#xF5;es.</span>

ansible-playbook -i hosts playbook-criada.yml --limit host <span class="hljs-comment">#ignora os hosts e roda apenas no definido pelo limit.</span>

ansible-playbook -i hosts  playbook-criada.yml --forks=NUMERO <span class="hljs-comment">#expecifica o n&#xFA;mero de processos a serem executados em paralelo.</span>

ansible-playbook -i hosts  playbook-criada.yml --list-hosts <span class="hljs-comment">#lista os hosts configurados.</span>

ansible-playbook -i hosts  playbook-criada.yml --list-tasks <span class="hljs-comment">#lista as tasks configuradas.</span>
</code></pre>
<h2 id="ansible-vault">Ansible Vault</h2>
<p>Featue do ansible utilizado para criptografar arquivos com dados sens&#xED;veis.</p>
<pre><code class="lang-bash">ansible-vault create passwd.yml

ansible-vault edit passwd.yml

ansible-vault view passwd.yml

ansible-vault encrypt passwd.yml

ansible-vault decrypt passwd.yml
</code></pre>

                                
                                </section>
                            
    </div>
    <div class="search-results">
        <div class="has-results">
            
            <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
            <ul class="search-results-list"></ul>
            
        </div>
        <div class="no-results">
            
            <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
            
        </div>
    </div>
</div>

                        </div>
                    </div>
                
            </div>

            
                
                <a href="Vagrant.html" class="navigation navigation-prev " aria-label="Previous page: Vagrant">
                    <i class="fa fa-angle-left"></i>
                </a>
                
                
                <a href="Docker.html" class="navigation navigation-next " aria-label="Next page: Docker">
                    <i class="fa fa-angle-right"></i>
                </a>
                
            
        
    </div>

    <script>
        var gitbook = gitbook || [];
        gitbook.push(function() {
            gitbook.page.hasChanged({"page":{"title":"Ansible","level":"1.3","depth":1,"next":{"title":"Docker","level":"1.4","depth":1,"path":"Docker.md","ref":"Docker.md","articles":[]},"previous":{"title":"Vagrant","level":"1.2","depth":1,"path":"Vagrant.md","ref":"Vagrant.md","articles":[]},"dir":"ltr"},"config":{"gitbook":"*","theme":"default","variables":{},"plugins":[],"pluginsConfig":{"highlight":{},"search":{},"lunr":{"maxIndexSize":1000000,"ignoreSpecialCharacters":false},"sharing":{"facebook":true,"twitter":true,"google":false,"weibo":false,"instapaper":false,"vk":false,"all":["facebook","google","twitter","weibo","instapaper"]},"fontsettings":{"theme":"white","family":"sans","size":2},"theme-default":{"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"},"showLevel":false}},"structure":{"langs":"LANGS.md","readme":"README.md","glossary":"GLOSSARY.md","summary":"SUMMARY.md"},"pdf":{"pageNumbers":true,"fontSize":12,"fontFamily":"Arial","paperSize":"a4","chapterMark":"pagebreak","pageBreaksBefore":"/","margin":{"right":62,"left":62,"top":56,"bottom":56}},"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"}},"file":{"path":"Ansible.md","mtime":"2021-09-30T00:09:28.967Z","type":"markdown"},"gitbook":{"version":"3.2.3","time":"2021-10-04T12:07:47.563Z"},"basePath":".","book":{"language":""}});
        });
    </script>
</div>

        
    <script src="gitbook/gitbook.js"></script>
    <script src="gitbook/theme.js"></script>
    
        
        <script src="gitbook/gitbook-plugin-search/search-engine.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-search/search.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/lunr.min.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/search-lunr.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-sharing/buttons.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-fontsettings/fontsettings.js"></script>
        
    

    </body>
</html>

